EDIT - bug #6309

Creating an existing user throws exception
01/04/2017 02:34 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 50%
Category: taxeditor Estimated time: 2:00 hours
Target version: Release 4.6

Severity: normal Found in Version:

Description

When creating a user with a username that does already exist throws an "unexpected error".

Instead an expected error handling should be used by either catching the exception accordingly or even better, run a request if the
username exists already, before creating the user.

login : admin
editor version : 4.4.1
server : api.cybertaxonomy.org / cybertaxonomy.org
schema version : 4.1.0.0.201607300000
os : Windows Server 2012 6.2 amd64
java : 1.7.0_65
java.lang.RuntimeException: Error executing command

at eu.etaxonomy.taxeditor.bulkeditor.command.DynamicNewObjectMenu$2.widgetSelected (DynamicNewO
bjectMenu. java:82)

at org.eclipse.swt.widgets.TypedListener.handleEvent (TypedListener. java:240)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1053)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4165)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display. java:3754)

at org.eclipse.ui.internal.Workbench.runEventLoop (Workbench. java:2701)

at org.eclipse.ui.internal.Workbench.runUI (Workbench.java:2665)

at org.eclipse.ui.internal.Workbench.access$4 (Workbench. java:2499)

at org.eclipse.ui.internal.Workbench$7.run (Workbench. java:679)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:332)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:110)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:
79)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:344)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter.java:179)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:57)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:606)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)

at org.eclipse.equinox.launcher.Main.run (Main.java:1410)
Caused by: org.springframework.dao.DatalntegrityViolationException: could not execute statement; S
QL [n/al]; constraint [UK_csivo9yga08nrbkog7lycilh5]; nested exception is org.hibernate.exception.C
onstraintViolationException: could not execute statement

at org.springframework.orm.hibernateb.SessionFactoryUtils.convertHibernateAccessException (Sess
ionFactoryUtils. java:164)

at org.springframework.orm.hibernateb5.HibernateTransactionManager.convertHibernateAccessExcept
ion (HibernateTransactionManager. java:741)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactio
nManager.java:589)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.processCommit (Ab
stractPlatformTransactionManager. java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (AbstractP
latformTransactionManager. java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionAfter
Returning (TransactionAspectSupport. java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.security.access.intercept.aopalliance.MethodSecurityInterceptor.invoke (
MethodSecurityInterceptor.java:68)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy9580.createUser (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.RAopUtils.invokeJoinpointUsingReflection (AopUtils.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.remoting.support.RemoteInvocationTraceInterceptor.invoke (RemoteInvocati
onTraceInterceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy9679.createUser (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemotelInvocation. java:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (DefaultRemoteIn
vocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemoteInvocationB
asedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResult (Re
moteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvok
erServiceExporter. java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdap
ter.java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:959)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:969)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:871)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:316)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTransl
ationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManagement
Filter.java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.authentication.AnonymousAuthenticationFilter.doFilter (Anon
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr

security.web.FilterChainProxy.doFilterInternal (FilterChainProxy.java:21

security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)
web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. j

web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:26

.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)

web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFi

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
servlet.ServletHandler.doHandle (ServletHandler. java:585)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:577)
server.session.SessionHandler.doHandle (SessionHandler. java:223)
server.handler.ContextHandler.doHandle (ContextHandler.java:1127)
servlet.ServletHandler.doScope (ServletHandler. java:515)

session.
handler.
.handler.
handler.

SessionHandler.doScope (SessionHandler. java:185)
ContextHandler.doScope (ContextHandler. java:1061)
ScopedHandler.handle (ScopedHandler. java:141)
ContextHandlerCollection.handle (ContextHandlerCollection. j
.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
Server.handle (Server.java:497)

.HttpChannel.handle (HttpChannel. java:310)
.HttpConnection.onFillable (HttpConnection. java:257)

io.AbstractConnection$2.run (AbstractConnection. java:540)
util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
java.lang.Thread.run (Thread. java:745)

remoting.support.RemoteInvocationUtils.fillInClientStackTraceIfPossible

(RemoteInvocationUtils. java:45)
at org.springframework.remoting. support.RemoteInvocationResult.recreate (RemoteInvocationResult
.java:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemotelInvocation
Result (RemoteInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerCli
entInterceptor.java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy7.createUser (Unknown Source)

at eu.etaxonomy.taxeditor.bulkeditor.input.entitycreator.UserCreator.createEntity (UserCreator.
java:46)

at eu.etaxonomy.taxeditor.bulkeditor.input.entitycreator.UserCreator.createEntity (UserCreator.
java:l)

at eu.etaxonomy.taxeditor.annotatedlineeditor.AnnotatedLineEditor.createAnnotatedLineNewObject
(AnnotatedLineEditor. java:160)

at eu.etaxonomy.taxeditor.annotatedlineeditor.handler.NewObjectHandler.execute (NewObjectHandle
r.java:80)

at org.eclipse.ui.internal.handlers.HandlerProxy.execute (HandlerProxy.java:293)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:476)

at org.eclipse.ui.internal.handlers.HandlerService.executeCommand (HandlerService.java:178)

at eu.etaxonomy.taxeditor.bulkeditor.command.DynamicNewObjectMenus$2.widgetSelected (DynamicNewO
bjectMenu. java:79)

25 more

Caused by: org.hibernate.exception.ConstraintViolationException: could not execute statement

at org.hibernate.exception.internal.SQLExceptionTypeDelegate.convert (SQLExceptionTypeDelegate.
java:59)

at org.hibernate.exception.internal.StandardSQLExceptionConverter.convert (StandardSQLException
Converter. java:42)

at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper. java:109)

at org.hibernate.engine. jdbc.spi.SqglExceptionHelper.convert (SglExceptionHelper. java:95)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. ja
va:207)

at org.hibernate.engine. jdbc.batch.internal.NonBatchingBatch.addToBatch (NonBatchingBatch. java:
45)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister. java:
2886)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister. java:
3386)

at org.hibernate.action.internal.EntityInsertAction.execute (EntityInsertAction. java:89)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:560)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:434)

at org.hibernate.event.internal.AbstractFlushingEventListener.performExecutions (AbstractFlushi
ngEventListener. java:337)

at org.hibernate.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEventListener. ja
va:39)

at org.hibernate.internal.SessionImpl.flush (SessionImpl.java:1282)

at org.hibernate.internal.SessionImpl.managedFlush (SessionImpl. java:465)

at org.hibernate.internal.SessionImpl.flushBeforeTransactionCompletion (SessionImpl. java:2963)

at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java:2339)

at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionCompletion (JdbcCoor
dinatorImpl. java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordi
natorImpl.beforeCompletionCallback (JdbcResourcelLocalTransactionCoordinatorImpl. java:147)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordi
natorImpl.access$100 (JdbcResourcelLocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordi
natorImpl$TransactionDriverControlImpl.commit (JdbcResourceLocalTransactionCoordinatorImpl. java:231
)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImpl. java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactio
nManager. java:581)

130 more

Caused by: com.mysqgl.jdbc.exceptions. jdbcd4.MySQLIntegrityConstraintViolationException: Duplicate e
ntry 'ab' for key 'UK_csivo9yga0O8nrbkog7lycilh5'

at sun.reflect.NativeConstructorAccessorImpl.newInstance0 (Native Method)

at sun.reflect.NativeConstructorAccessorImpl.newInstance (NativeConstructorAccessorImpl. java:62
at sun.

.java:45)

reflect.DelegatingConstructorAccessorImpl.newInstance (DelegatingConstructorAccessorImpl

at java.lang.reflect.Constructor.newInstance (Constructor.java:423)

at com.
at com.
at com.
at com.
.mysgl.jdbc.MysglIO.checkErrorPacket (MysqlIO. java:3814)
at com.

at com

at com.

at com

at com.
at com.
at com.

at com
at com
java:384)

at org.

va:204)

mysqgl. jdbc.Util.handleNewInstance (Util. java:404)

mysqgl. jdbc.Util.getInstance (Util. java:387)

mysql. jdbc.SQLError.createSQLException (SQLError. java:932)
mysqgl. jdbc.MysglIO.checkErrorPacket (MysglIO. java:3878)

mysqgl. jdbc.MysglIO. sendCommand (MysqlIO. java:2478)
mysqgl. jdbc.MysqglIO.sglQueryDirect (MysglIO. java:2625)

.mysql. jdbc.ConnectionImpl.execSQL (ConnectionImpl.java:2551)
at com.

mysqgl. jdbc.PreparedStatement .executeInternal (PreparedStatement.java:1861)
mysql. jdbc.PreparedStatement .executeUpdatelInternal (PreparedStatement. java:2073)
mysqgl. jdbc.PreparedStatement .executeUpdateInternal (PreparedStatement. java:2009)
mysqgl. jdbc.PreparedStatement .executelargeUpdate (PreparedStatement. java:5094)

.mysgl.jdbc.PreparedStatement.executeUpdate (PreparedStatement.java:1994)
.mchange.v2.c3p0.impl.NewProxyPreparedStatement .executeUpdate (NewProxyPreparedStatement.

hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. ja

148 more

Associated revisions

Revision afc2457c¢ - 02/02/2017 01:54 PM - Katja Luther

fix #6309: check for existence of user before saving a new user

Revision b6bb07b9 - 02/02/2017 04:41 PM - Patrick Plitzner

ref #6309 Add missing 110n String constant to Messages.java

History

#1 - 01/05/2017 02:42 PM - Andreas Miiller
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to COM UML 4.7

- Estimated time set to 2:00 h

#3 - 02/02/2017 01:54 PM - Katja Luther

- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|afc2457c7a4661cd1577fd486211da032354a61c.

#4 - 02/02/2017 01:56 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

added a check for existence of users with the same username before saving the new user

#5 - 03/01/2017 03:32 PM - Andreas Miiller
- Target version changed from CDM UML 4.7 to Release 4.6

#6 - 03/01/2017 03:34 PM - Andreas Miiller

- Status changed from Resolved to Closed

- Assignee changed from Andreas Muiller to Katja Luther

Seems to work
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/afc2457c7a4661cd1577fd486211da032354a61c
